statistic/urls.py
from django.conf.urls import url
from .views import index

urlpatterns = [
    url(r'^$', index, name='index'),
]

tugas1_Profile/urls.py
from django.conf.urls import url
from .views import index
#url for app
urlpatterns = [
    url(r'^$', index, name='index'),
]

tugas1_add_friend/urls.py
from django.conf.urls import url
from .views import index, add_friend

urlpatterns = [
    url(r'^$', index, name='index'),
    url(r'^friend', add_friend, name='add_friend'),
 ]

tugas1_ppw/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.views.generic.base import RedirectView
import tugas1_Profile.urls as profile
import tugas1_statistic.urls as statistic
import tugas1_update_status.urls as update_status
import tugas1_add_friend.urls as add_friend

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^profile/', include(profile, namespace='profile')),
    url(r'^add_friend/', include(add_friend, namespace='add_friend')),
    url(r'^friend/', include(add_friend, namespace='friend')),
    url(r'^statistic/', include(statistic, namespace='statistic')),
    url(r'^update-status/', include(update_status, namespace='update-status')),
    url(r'^$', RedirectView.as_view(url="/update-status/", permanent="true"), name='index')
]

tugas1_statistic/urls.py
from django.conf.urls import url
from .views import index

urlpatterns = [
    url(r'^$', index, name='index'),
]

tugas1_update_status/urls.py
from django.conf.urls import url
from .views import index, add_status

urlpatterns = [
    url(r'^$', index, name='index'),
    url(r'^add_status', add_status, name='add_status'),
]

tugas1_Profile/models.py
from django.db import models

# Create your models here.

tugas1_add_friend/models.py
from django.db import models

class Todo(models.Model):
    name = models.CharField(max_length=30)
    url = models.URLField()
    created_date = models.DateTimeField(auto_now_add=True)

tugas1_statistic/models.py
from django.db import models

# Create your models here.

tugas1_update_status/models.py
from django.db import models

class Status(models.Model):
    description = models.TextField()
    created_date = models.DateTimeField(auto_now_add=True)

tugas1_add_friend/forms.py
from django import forms

class Friend_Form(forms.Form):
    error_messages = {
        'required': 'Tolong isi input ini',
        'invalid': 'Isi input dengan link heroku',
    }
    attrs = {
        'class': 'form-control'
    }
    name = forms.CharField(label='Nama', required=True, max_length=30, widget=forms.TextInput(attrs=attrs))
    url = forms.URLField(label='URL', required=True, widget=forms.URLInput(attrs=attrs))

tugas1_update_status/forms.py
from django import forms

class Status_Form(forms.Form):
    error_messages = {
        'required': 'Tolong isi input ini',
    }
    description_attrs = {
        'type': 'text',
        'cols': 50,
        'rows': 4,
        'class': 'status-form-textarea',
        'placeholder':'Masukan status...'
    }

    description = forms.CharField(label='', required=True, widget=forms.Textarea(attrs=description_attrs))

statistic/views.py
from django.shortcuts import render
from Profile.views import name

# Create your views here.

def index(request):
    response = {"name" : name}
    return render(request, 'statistic/statistik.html', response)

tugas1_Profile/views.py
from django.shortcuts import render

# Create your views here.
name = "V"
bio_dict = [
    {'subject': 'Birth Date', 'value':'1 Januari'},
    {'subject': 'Genderender', 'value': 'Male'},
    {'subject': 'Description', 'value': 'I am anonymous'},
    {'subject': 'E-mail', 'value':'V@gmail.com'},
]
list_expertise = ['eat', 'drink', 'have fun']
author = "Tugas 1 PPW"

def index(request):
    response = {'bio' : bio_dict, "name" : name}
    response['expertise'] = list_expertise
    response['author'] = author
    return render(request, 'profilePage.html', response)

tugas1_add_friend/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponseRedirect
from django import forms
from .forms import Friend_Form
from .models import Todo

# Create your views here.
response = {} #TODO Implement yourname
html = 'add_friend.html'
def index(request):
    friend = Todo.objects.all()
    response['author'] = 'Tugas 1 PPW'
    response['friend'] = friend
    response['friend_form'] = Friend_Form
    return render(request, html, response)

def add_friend(request):
    form = Friend_Form(request.POST or None)
    if(request.method == 'POST' and form.is_valid()):
        if(url_is_valid(request.POST['url'])):
            friend = Todo(name=request.POST['name'], url=request.POST['url'])
            friend.save()   
            return redirect('/friend/',{'error':False})
    return redirect('/friend/',{'error':True})

def url_is_valid(url):
    url_form_field = forms.URLField()
    try:
        url = url_form_field.clean(url)
    except ValidationError:
        return False
    return True

tugas1_statistic/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from tugas1_add_friend.models import Todo
from tugas1_update_status.models import Status
from tugas1_Profile.views import name

# Create your views here.
response = {}
def index(request):    
    response['author'] = "Wilda" #TODO Implement yourname
    
    bnyk_temen = Todo.objects.all().count()
    response['friend']= bnyk_temen 

    bnyk_status = Status.objects.all().count()
    response['status'] = bnyk_status

    nama_profile = name
    response['nameP'] = nama_profile

    if bnyk_status > 0:
        response['lastT'] = Status.objects.last().created_date
        response['lastP'] = Status.objects.last().description
    else:
        response['lastT'] = "__-__"
        response['lastP'] = "no post"

    html = 'statistic/statistik.html'
    
    return render(request, html, response)

tugas1_update_status/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from .forms import Status_Form
from .models import Status

# Create your views here.
response = {}
def index(request):    
    response['author'] = "" #TODO Implement yourname
    status = Status.objects.all()
    response['status'] = status
    html = 'tugas1_update_status/tugas1_update_status.html'
    response['status_form'] = Status_Form
    return render(request, html, response)

def add_status(request):
    form = Status_Form(request.POST or None)
    if(request.method == 'POST' and form.is_valid()):
        response['description'] = request.POST['description']
        status = Status(description=response['description'])
        status.save()
        return HttpResponseRedirect('/update-status/')
    else:
        return HttpResponseRedirect('/update-status/')

statistic/templates/statistic/statistik.html
{% extends "statistic/layout/base.html" %}

{% block content %}

<h1>Halo, ini {{ name }}</h1>

{% endblock %}

tugas1_Profile/templates/base.html
<!DOCTYPE html>
<html lang = "en">
<head>
<meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <!-- bootstrap csss -->
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css" rel="stylesheet">
	<title>Profil</title>
	<link rel = "stylesheet" href = "https://www.w3schools.com/w3css/4/w3.css">
</head>
<body>
	<header>
	{% include "statistic/partials/header.html" %}
	</header>
	
	<content>
		<div class = "container">
			{% block content %}
			{% endblock %}
		</div>
	</content>
	
	<footer>
		{% include "statistic/partials/footer.html" %}
	</footer>
</body>
</html>

tugas1_Profile/templates/profilePage.html
{% extends "base.html" %}
{% block content %}
<style>
	.profile_picture{
		display : block;
		margin : auto;
		border-radius : 50%;
	}
	
	table, th, td {
		border: 20px solid white;
		border-collapse: collapse;
	}
	
	th, td {
		padding: 5px;
		text-aligne; left;
	}
</style>

<h1 class = "main-title">Profile</h1>
	<div class = "image" style = "text-align: center">
	<br>
		<img class = "profile_picture"src = "http://philipcoppens.com/vendetta_07.jpg">
	</div>
	<h2 style = "text-align: center">{{name}}</h2>
	<table align = "center">
		{% for bio in bio %}
			<tr>
				<td class = "subject" align = "left">{{bio.subject}}</td>
				<td class = "value" align = "right">{{bio.value}}</td>
			</tr>
		{% endfor %}
		<tr>
			<td class = "subject" align = "left">Expertise </td>
			<td class = "vallue" align = "right">{% for exp in expertise %}
				<span class = "w3-tag w3-small w3-padding-small"><li>{{exp}}</li></span>
				{% endfor %}
			</td>
		</tr>
		
	</table>
{% endblock %}

tugas1_add_friend/templates/add_friend.html
{% extends "layout/base.html" %}
{% load static %}

{% block title %} Friends {% endblock %}

{% block style %}
<link rel="stylesheet" type="text/css" href="{% static 'css/add_friend.css' %}" />
{% endblock %}


{% block content %}
<section name="form" style="border:1px solid black;background-color: rgba(255,255,255,0.6);">
    <h2 class="my-list-title">Add Friend</h2>
        <form id="form" class="form-horizontal" method="POST" action="{% url 'add_friend:add_friend' %}">
            {% csrf_token %}
            {{ friend_form }}
            <br>
            <button type="submit" class="btn btn-default">Add Friend</button>
        </form>
    </section>
    <br>
<section name='table'>
    <h2 class="my-list-title">Friend List</h2>
	<div class="flex">
 	<table class="table">
		<!-- <thead> -->
<!-- 			<th id="name" align="left">Name</th>
			<th id="url" align="center">Url</th>
			<th id="date" align="right">Date Added</th> -->
		<!-- </thead>
		<tbody> -->
			{% for i in friend %}
			{% if i.name == 'Anonymous' or i.url == 'Anonymous' %}
			<tr class="warning"> {% else %} <tr class="success">
				{% endif %}
				<div class="flex-item">
				<div class="to-do-list-title" align="left" margin="auto">
					{{i.name}}
				</div>
				<div class="to-do-list-date-added" align="right" margin="auto">
					Added on {{ i.created_date.date }} {{ i.created_date.time }}
				</div>
				<div class="to-do-list-description" align="center">
					<a href="{{i.url}}">{{i.url}}</a>
				</div>
			</div>
			</tr>             
			{% endfor %}
 		<!-- </tbody> -->
	</table>
	</tr>
	</div>
</section>

{% endblock %}

tugas1_add_friend/templates/layout/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="description" content="LAB 4">
    <meta name="author" content="{{author}}">
    <!-- bootstrap csss -->
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css" rel="stylesheet">    

    <title> 
        {% block title %} Tugas 1 PPW By {{author}}{% endblock %}
    </title>
</head>
<body>
    <header>
    {% include "statistic/partials/header.html" %}
    </header>
    {% block content %}
    {% endblock %}
    <footer>
        <!-- TODO Block Footer dan include footer.html -->
        {% block footer %}
        {% include "statistic/partials/footer.html" %}
        {% endblock %}
    </footer>
    <!-- Jquery n Bootstrap Script -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script type="application/javascript" src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</body>
</html>

tugas1_statistic/templates/statistic/layout/base.html
{% load staticfiles %}
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="description" content="LAB 5">
    <!-- bootstrap csss -->
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css" rel="stylesheet">
   <!-- <link rel="stylesheet" type="text/css" href="{% static 'css/lab_5.css' %}" /> -->


    <title>
        Dashboard
    </title>
</head>

<body>
    <header>
        {% include "statistic/partials/header.html" %}
    </header>
    <content>
            {% block content %}
                <!-- content goes here -->
            {% endblock %}
    </content>
    <footer>
        <!-- TODO Block Footer dan include footer.html -->
        {% block footer %}
        {% include "statistic/partials/footer.html" %}
        {% endblock %}
    </footer>

</body>
</html>

tugas1_statistic/templates/statistic/partials/footer.html
<p>&copy; {{author}}</p>

tugas1_statistic/templates/statistic/partials/header.html
   <!-- Fixed navbar -->
    <nav class="navbar navbar-default navbar-static-top">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="#">LingIn</a>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
          <ul class="nav navbar-nav">
            <!-- LINK MENUJU table, dan link menuju home#form -->
            <li><a href="/update-status/">status</a></li>
            <li><a href="/profile/">profile</a></li>
            <li><a href="/add_friend/">friends</a></li>
            <li><a href="/statistic/">stats</a></li>
          </ul>
        </div><!--/.nav-collapse -->
      </div>
    </nav>

tugas1_statistic/templates/statistic/statistik.html
{% extends "statistic/layout/base.html" %}

{% block content %}
<div class="container">
	<div class="row">
		<div class="col-sm-offset-2 col-sm-8">
			<div class="col-sm-5">
				<img class = "img-circle" width="75px" src = "http://philipcoppens.com/vendetta_07.jpg">
			</div>
			<div class="col-sm-7">
				<h1>{{ name }}</h1>
			</div>
		</div>
	</div>
</div>

<div class="container">
	<div class="row">
		<div class="col-sm-offset-2 col-sm-8">
			<div class="col-sm-6">
				<h3><strong>Friends:</strong> {{friend}} Friends</h3>
			</div>
			<div class="col-sm-6">
				<h3><strong>Feeds:</strong> {{status}} Feeds</h3>
			</div>
		</div>
	</div>
</div>

<div class="container">
	<div class="row">
		<div class="col-sm-offset-2 col-sm-8">
			<h2>Last Status</h2>
			<p>{{lastP}}</p>
            <p><small>Posted on {{lastT}}</small></p>
		</div>
	</div>
</div>
{% endblock %}

tugas1_update_status/templates/tugas1_update_status/layout/base.html
{% load staticfiles %}
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <!-- bootstrap csss -->
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css" rel="stylesheet">
    <link rel = "stylesheet" href = "https://www.w3schools.com/w3css/4/w3.css">

    <title>
        {% block title %} Update Status By {{author}} {% endblock %}
    </title>
</head>
    
<body>
    <header>
    {% include "statistic/partials/header.html" %}
    </header>
    <content>
            {% block content %}
                <!-- content goes here -->
            {% endblock %}
    </content>

    <!-- Jquery n Bootstrap Script -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script type="application/javascript" src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
    <script type="application/javascript">
      $(function() {
          $('a[href*="#"]:not([href="#"])').click(function() {
            if (location.pathname.replace(/^\//,'') == this.pathname.replace(/^\//,'') && location.hostname == this.hostname) {
              var target = $(this.hash);
              target = target.length ? target : $('[name=' + this.hash.slice(1) +']');
              if (target.length) {
                $('html, body').animate({
                  scrollTop: target.offset().top - 55
                }, 1000);
                return false;
              }
            }
          });
        });
    </script>
</body>
</html>

tugas1_update_status/templates/tugas1_update_status/tugas1_update_status.html
{% extends "tugas1_update_status/layout/base.html" %}

{% block content %}
<section name="input-status" id="input-status">
    <div class="container">
        <form id="form" method="POST" action="{% url 'update-status:add_status' %}">
            <h2>Update Status</h2>
            {% csrf_token %}
            {{ status_form }}
            <input id="submit" type="submit" class="btn btn-lg btn-block btn-info" value="Submit">
            <br>
        </form>
    </div>
</section>
<section name="my-status" id="my-status">
    <div class="container">
        <hr/>
        <div class="flex">
            {% if status %}
                {% for data in status reversed %}
                    <div class="flex-item">
                        <div class="update-status">
                            <div class="update-status-date-added">
                                {{data.created_date}}
                            </div>
                            <div class="update-status-description">
                                {{data.description}}
                            </div>
                            <div class="update-status-delete">
                                <div class="update-status-delete-button" data-id="{{data.id}}">Delete</div>
                            </div>
                        </div>
                    </div>
                {% endfor %}
            {% else %}
            <div class="alert alert-danger text-center">
                <strong>Oops!</strong> Tidak ada data Todo.
            </div>
            {% endif %}
        </div>
    </div>
</section>

{% endblock %}   